1#!/bin/sh
2#
3#	aegis - project change supervisor
4#	Copyright (C) 1999, 2006-2008 Peter Miller
5#
6#	This program is free software; you can redistribute it and/or modify
7#	it under the terms of the GNU General Public License as published by
8#	the Free Software Foundation; either version 3 of the License, or
9#	(at your option) any later version.
10#
11#	This program is distributed in the hope that it will be useful,
12#	but WITHOUT ANY WARRANTY; without even the implied warranty of
13#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
14#	GNU General Public License for more details.
15#
16#	You should have received a copy of the GNU General Public License
17#	along with this program. If not, see
18#	<http://www.gnu.org/licenses/>.
19#
20
21unset AEGIS_PROJECT
22unset AEGIS_CHANGE
23unset AEGIS_PATH
24unset AEGIS
25umask 022
26
27LINES=24
28export LINES
29COLS=80
30export COLS
31
32USER=${USER:-${LOGNAME:-`whoami`}}
33
34work=${AEGIS_TMP:-/tmp}/$$
35PAGER=cat
36export PAGER
37AEGIS_FLAGS="delete_file_preference = no_keep; \
38	lock_wait_preference = always; \
39	diff_preference = automatic_merge; \
40	pager_preference = never; \
41	persevere_preference = all; \
42	log_file_preference = never;"
43export AEGIS_FLAGS
44AEGIS_THROTTLE=-1
45export AEGIS_THROTTLE
46
47here=`pwd`
48if test $? -ne 0 ; then exit 2; fi
49
50bin=$here/${1-.}/bin
51
52pass()
53{
54	set +x
55	echo PASSED 1>&2
56	cd $here
57	find $work -type d -user $USER -exec chmod u+w {} \;
58	rm -rf $work
59	exit 0
60}
61fail()
62{
63	set +x
64	echo "FAILED test of the aenpr -keep functionality ($activity)" 1>&2
65	cd $here
66	find $work -type d -user $USER -exec chmod u+w {} \;
67	rm -rf $work
68	exit 1
69}
70no_result()
71{
72	set +x
73	echo "NO RESULT when testing the aenpr -keep functionality ($activity)" 1>&2
74	cd $here
75	find $work -type d -user $USER -exec chmod u+w {} \;
76	rm -rf $work
77	exit 2
78}
79trap \"no_result\" 1 2 3 15
80
81activity="working directory 84"
82mkdir $work $work/lib
83if test $? -ne 0 ; then no_result; fi
84chmod 777 $work/lib
85if test $? -ne 0 ; then no_result; fi
86cd $work
87if test $? -ne 0 ; then no_result; fi
88
89#
90# use the built-in error messages
91#
92AEGIS_MESSAGE_LIBRARY=$work/no-such-dir
93export AEGIS_MESSAGE_LIBRARY
94unset LANG
95unset LANGUAGE
96
97#
98# test the aenpr -keep functionality
99#
100activity="create project 103"
101$bin/aegis -npr test -lib $work/lib -dir $work/proj -v > LOG 2>&1
102if test $? -ne 0 ; then cat LOG; fail; fi
103
104activity="remove project 107"
105$bin/aegis -rmpr test -lib $work/lib -keep -v > LOG 2>&1
106if test $? -ne 0 ; then cat LOG; no_result; fi
107
108activity="new project -keep 112"
109$bin/aegis -npr test -lib $work/lib -dir $work/proj -keep -v > LOG 2>&1
110if test $? -ne 0 ; then cat LOG; fail; fi
111
112#
113# Only definite negatives are possible.
114# The functionality exercised by this test appears to work,
115# no other guarantees are made.
116#
117pass
118